{% extends "base.html" %}
{% set active_page = "launch" %}
{% block body %}
<form action="/launch" id="uploadForm" method="POST" enctype=multipart/form-data>
  <fieldset class="uk-fieldset">

    <legend class="uk-legend">Launch a Workflow</legend>

    <div class="uk-margin">
      <label>Workflow Type:</label>
      <br>

      {% block content %}
      {% for workflow in workflows%}
      <div>
        <input type="radio" name="type" id="{{ workflow.type }}" value="somatic-illumina-solid">
        <label for="{{ workflow.type }}">{{ workflow.display_name }}</label>
        <div class="reveal-if-active">
          {% for rp in workflow.inputs_parameters.required%}
          <label for="{{rp.name}}">{{rp.display_name}}:</label>
          <input type="file" id="{{rp.name}}" name="{{rp.name}}" class="require-if-active" data-require-pair="#{{ workflow.type }}">
          <br>
          {% endfor %}
          {% for op in workflow.inputs_parameters.optional%}
          <label for="{{op.name}}">{{op.display_name}}:</label>
          <input type="file" id="{{op.name}}" name="{{op.name}}" class="optional">
          <br>
          {% endfor %}
        </div>
      </div>
      {% endfor %} 
    </div>

    <div class="uk-margin">
      <label>Referral number (Αριθμός Παραπεμπτικού): <input name="orderId" class="uk-input" type="text"
          placeholder="Order Id" id="orderId"></label>
    </div>
    {% if status is defined%}
    <br>
    {{ status }}
    <br> <br>
    {% endif %}
    {% endblock %}
    <div class="uk-margin" id="statusText" style="display:none">
      Please wait for further processing of your request.
    </div>
    <button type="submit" id="submitButton" class="uk-button uk-button-primary uk-button-large">Submit</button>
    <div class="uk-margin" id="uploadingText" style="display:none">
      Uploading the files, please wait.
    </div>
    <div class="w3-light-grey" id="progressBar" style="display:none">
      <div class="w3-blue" id="progressBarFill" role="progressbar" style="width: 0%" aria-valuenow="0" aria-valuemin="0"
        aria-valuemax="100">
        <span class="progress-bar-text" id="progressBarText">0%</span>
      </div>
    </div>

  </fieldset>
</form>


<script>
  var uploadForm = document.getElementById("uploadForm");
  var progressBar = document.getElementById("progressBar");
  var progressBarFill = document.getElementById("progressBarFill");
  var progressBarText = document.getElementById("progressBarText");
  var statusText = document.getElementById("statusText")
  var uploadText = document.getElementById("uploadingText");
  var submitButton = document.getElementById("submitButton");
  uploadForm.addEventListener("submit", uploadFile);

  function uploadFile(e) {
    e.preventDefault();
    var xhr_orderid = new XMLHttpRequest();
    // if (checkOrderId() == false) {
    //   statusText.innerText = "Invalid Referral Number!\n The Referral Number must be of the form XXXX-XXXXX-XXXX where X is any digit or YYMMDDXXXXXXX.";
    //   statusText.style.display = '';
    //   return;
    // }
    xhr_orderid.open("POST", "/checkorderid");
    xhr_orderid.onreadystatechange = function () {
      if (xhr_orderid.readyState == XMLHttpRequest.DONE && xhr_orderid.status == 200) {
        if (xhr_orderid.responseText == "taken") {
          statusText.style.display = '';
          statusText.innerText = "This Referral Number is already taken!";
        }
        else if (xhr_orderid.responseText == "not_valid") {
          statusText.innerText = "The Referral Number must be of the form XXXX-XXXXX-XXXX or of the form YYMMDDXXXXXXX where X is any digit.";
          statusText.style.display = '';
        }
        else if (xhr_orderid.responseText == "not_taken") {
          sendForm();
        }
        else {
          statusText.style.display = '';
          statusText.innerText = xhr_orderid.responseText;
        }
      }
    }
    var miniForm = new FormData();
    miniForm.append("orderId", document.getElementById("orderId").value);
    xhr_orderid.send(miniForm);
  }

  function sendForm() {
    var xhr = new XMLHttpRequest();
    xhr.open("POST", "/launch");
    xhr.upload.addEventListener("progress", e => {
      console.log(e);
      const percent = e.lengthComputable ? (e.loaded / e.total) * 100 : 0;

      progressBarFill.style.width = percent.toFixed(2) + "%";
      progressBarText.textContent = percent.toFixed(2) + "%";
      if (percent == 100) {
        statusText.style.display = '';
      }
    });

    statusText.style.display = 'none';
    xhr.onreadystatechange = function () {
      if (xhr.readyState == XMLHttpRequest.DONE) {
        statusText.innerText = xhr.responseText;
        statusText.style.display = '';
        uploadText.style.display = 'none'
        progressBar.style.display = 'none'
        submitButton.style.display = '';
      }

    }

    data = new FormData(uploadForm);
    showProgressBar();
    xhr.send(data);
  }


  function showProgressBar() {
    if (uploadText.style.display == 'none') {
      uploadText.style.display = '';
    }
    if (progressBar.style.display == 'none') {
      progressBar.style.display = '';
    }
    submitButton.style.display = 'none';
  }

  function applyOptionalCleanup() {
    $(".optional").each(function () {
      var el = $(this);
      if (!$(el.data("require-pair")).is(":checked")) {
        el.val('');
      }
    });
  }
  var FormStuff = {
    init: function () {
      this.applyConditionalRequired();
      // this.applyOptionalCleanup1()
      this.bindUIActions();
    },
    bindUIActions: function () {
      $("input[type='radio'], input[type='checkbox']").on("change", this.applyConditionalRequired);
    },
    applyConditionalRequired: function () {
      $(".require-if-active").each(function () {
        var el = $(this);
        if ($(el.data("require-pair")).is(":checked")) {
          el.prop("required", true);
        } else {
          el.val('');
          el.prop("required", false);
        }
      });
      applyOptionalCleanup();
    }

  };
  FormStuff.init();

  function checkOrderId() {
    var numbers_old = /^[0-9]{4}-[0-9]{5}-[0-9]{4}$/;
    var numbers_new = /^[0-9]{13}$/;
    var orderId;
    orderId = document.getElementById("orderId").value;
    document.getElementById("orderId").value = orderId.trim()
    orderId = document.getElementById("orderId").value;

    if (!orderId.match(numbers_old) && !orderId.match(numbers_new)) {
      return false;
    }
    else {
      return true;
    }
  }

</script>
{% endblock %}